﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
'v.0.12 Pin object: line + two connection points

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Public mLine, mPoint1, mPoint2 As B4XView, mRoot As B4XView
	Public LineThinknessPx As Int = 2dip
	Public LineLenghtPx As Int = 20dip
	Public LineColor As Int = xui.Color_Blue
	Private PointSizePx As Int = LineThinknessPx * 5
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 
	
	mRoot = xui.CreatePanel("mRoot")
	mBase.AddView(mRoot, 0, 0, mBase.Width, mBase.Height)
	mRoot.SetColorAndBorder(xui.Color_Transparent, 1dip, xui.Color_ARGB(50, 0, 199, 0), 0)	'transparent container
	
	mPoint1 = xui.CreatePanel("mPoint1")
	mRoot.AddView(mPoint1, 0, 0, PointSizePx, PointSizePx)
	mPoint1.SetColorAndBorder(xui.Color_Transparent, LineThinknessPx, LineColor, PointSizePx)	'Connection point1 as square
	mPoint1.BringToFront
	
	mLine = xui.CreatePanel("")
	mRoot.AddView(mLine, PointSizePx , (PointSizePx  - LineThinknessPx) / 2, LineLenghtPx, LineThinknessPx)
	mLine.SetColorAndBorder(LineColor, 0, LineColor, 0)    'line as rectangle between Points
	
	mPoint2 = xui.CreatePanel("mPoint2")
	mRoot.AddView(mPoint2, PointSizePx + LineLenghtPx, 0, PointSizePx, PointSizePx)
	mPoint2.SetColorAndBorder(xui.Color_Transparent, LineThinknessPx, LineColor, PointSizePx)	'Connection point1 as square
	mPoint2.BringToFront
	
	mRoot.Width = mPoint2.Left + mPoint2.Width
	mRoot.Height = mPoint2.Top + mPoint2.Height
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	mLine.SetLayoutAnimated(0, 0, 0, Width, Height)
	mRoot.Width = Width
	mRoot.Height = Height
	Sleep(0)
End Sub

#if B4J
Private Sub mRoot_MouseClicked (EventData As MouseEvent)
	If EventData.PrimaryButtonPressed Then
		Log("Pin mRoot click")
		If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
			CallSub(mCallBack, mEventName & "_Click")
		End If
	Else if EventData.SecondaryButtonPressed Then
		Log("Pin mRoot longclick")
		If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
			CallSub(mCallBack, mEventName & "_LongClick")
		End If
	End If
End Sub
#else if B4A
Private Sub mRoot_Click
	Log("Pin mRoot click")
	If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
		CallSub(mCallBack, mEventName & "_Click")
	End If
End Sub
Private Sub mRoot_LongClick
	Log("Pin mRoot longclick")
	If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub
#end if

#if B4J
Private Sub mPoint1_MouseClicked (EventData As MouseEvent)
	If EventData.PrimaryButtonPressed Then
		Log("mPoint1 click")
		If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
			CallSub(mCallBack, mEventName & "_Click")
		End If
	Else if EventData.SecondaryButtonPressed Then
		Log("mPoint1 longclick")
		If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
			CallSub(mCallBack, mEventName & "_LongClick")
		End If
	End If
End Sub
#else if B4A
Private Sub mPoint1_Click
	Log("mPoint1 click")
	If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
		CallSub(mCallBack, mEventName & "_Click")
	End If
End Sub
Private Sub mPoint1_LongClick
	Log("mPoint1 longclick")
	If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub
#end if

#if B4J
Private Sub mPoint2_MouseClicked (EventData As MouseEvent)
	If EventData.PrimaryButtonPressed Then
		Log("mPoint2 click")
		If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
			CallSub(mCallBack, mEventName & "_Click")
		End If
	Else if EventData.SecondaryButtonPressed Then
		Log("mPoint2 longclick")
		If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
			CallSub(mCallBack, mEventName & "_LongClick")
		End If
	End If
End Sub
#else if B4A
Private Sub mPoint2_Click
	Log("mPoint2 click")
	If xui.SubExists(mCallBack, mEventName & "_Click", 0) Then
		CallSub(mCallBack, mEventName & "_Click")
	End If
End Sub
Private Sub mPoint2_LongClick
	Log("mPoint2 longclick")
	If xui.SubExists(mCallBack, mEventName & "_LongClick", 0) Then
		CallSub(mCallBack, mEventName & "_LongClick")
	End If
End Sub
#end if

'Private Sub Calc_First_For_Connection(FirstFigureSize As Float, FirstFigurePosition As Float, SecondFigurePosition As Float) As Float
'	Dim a As Float = 
'End Sub